import es, playerlib, popuplib, gamethread, usermsg, time, os.path, services

flasher = None
restricted = []

sv = es.ServerVar

sv_options = {
	'af_admins': 'STEAM_0:0:11089864,STEAM_0:1:12114951,STEAM_0:1:5774407,STEAM_0:0:11161506',
	'af_no_flash': 0
}

es.ServerVar('af_version', 1, 'Anti Flash made by Bonbon AKA Bonbon367').makepublic()

def load():
	if not es.exists('saycommand', '!punish'): es.regsaycmd('!punish', 'flash/punish2', 'Punish a player')
	if not es.exists('clientcommand', '!punish'): es.regclientcmd('!punish', 'flash/punish2', 'Punish a player')
	for option in sv_options:
		es.ServerVar(option).set(sv_options[option])
	if os.path.isfile(es.getAddonPath('flash') + '/flash.cfg'):
		es.server.cmd('es_xmexec ../addons/eventscripts/flash/flash.cfg')
	else:
		es.dbgmsg(0, 'Anti Flash: Config not found! Make sure it\'s under ../addons/eventscripts/flash/flash.cfg!')
	gamethread.delayed(0, set_admins)

def set_admins():
	global admins
	admins = str(sv('af_admins')).split(',')

def unload():
	if es.exists('saycommand', '!punish'): es.unregsaycmd('!punish')
	if es.exists('clientcommand', '!punish'): es.unregclientcmd('!punish')
	es.addons.unregisterClientCommandFilter(restrict_flash_filter)

def player_blind(ev):
	gamethread.delayed(0, player_blind2, int(ev['userid']))

def player_blind2(userid):
	if es.getplayerteam(userid) == es.getplayerteam(flasher):
		if playerlib.getPlayer(userid).get('flashalpha') > 75 and not int(userid) == int(flasher):
			if int(sv('af_no_flash')):
				es.server.queuecmd('playerset flashalpha %s 0;playerset flashduration %s 0'%(userid, userid))
			bmenu = popuplib.easymenu('Team Flasher', '_popup_choice', punish)
			bmenu.setdescription('%s flashed %s'%(playerlib.getPlayer(flasher).get('name'), playerlib.getPlayer(userid).get('name')))
			for option in ('Forgive', 'Warn', 'Slay', 'Restrict Flashbang', 'Kick', 'Ban'):
				bmenu.addoption([option, flasher], option)
			for userid2 in es.getUseridList():
				es.tell(userid2, '#multi', '#lightgreen%s#green flashed #lightgreen%s %s'%(playerlib.getPlayer(flasher).get('name'), playerlib.getPlayer(userid).get('name'), '#greentype #lightgreen!punish#green to punish' if is_authed(userid2) else ''))
			a = open(es.getAddonPath('flash') + '/flashes.txt', 'a')
			a.write('%s %s flashed %s for %s alpha and %s seconds with steamid %s\n'%(time.asctime(), playerlib.getPlayer(flasher).get('name'), playerlib.getPlayer(userid).get('name'), playerlib.getPlayer(userid).get('flashalpha'), playerlib.getPlayer(userid).get('flashduration'), playerlib.getPlayer(userid).get('steamid')))
			a.write('\n')
			a.close()

def is_authed(userid):
	if isAuthed(userid) or es.getplayersteamid(userid) in admins or (es.getplayersteamid(userid) in return_admins() and 'mani_admins' in admins):
		return 1
	return 0

def flashbang_detonate(ev):
	global flasher
	flasher = int(ev['userid'])

def punish(userid, choice, popupid):
	c = choice[0]
	u = choice[1]
	if c == 'Forgive':
		es.tell(u, '#green', 'An admin has forgiven you for teamflashing don\'t let it happen again!')
	elif c == 'Warn':
		tell(u)
	elif c == 'Slay':
		playerlib.getPlayer(u).set('health', 1)
		es.server.queuecmd('es_xfire %s !self ignite'%u)
		tell(u)
	elif c == 'Restrict Flashbang':
		rflash = popuplib.easymenu('Choose Time', '_popup_choice', rflash2)
		for a in (5, 10, 15, 30, 45, 60, 120, 240, 360):
			rflash.addoption([u, a], a)
		popuplib.send('Choose Time', userid)
	elif c == 'Kick':
		es.server.queuecmd('kickid %s Do Not Team Flash!'%u)
	elif c == 'Ban':
		ban = popuplib.easymenu('Chose Time', '_popup_choice', ban2)
		for a in (5, 10, 15, 30, 45, 60, 120, 240, 360):
			ban.addoption([a, u], a)
		popuplib.send('Chose Time', userid)
	if not c == 'Ban' and not c == 'Restrict Flashbang':
		es.tell(userid, '#multi', '#greenYou have executed #lightgreen%s#green on #lightgreen%s'%(c, playerlib.getPlayer(u).get('name')))

def ban2(userid, choice, popupid):
	#es.server.queuecmd('ma_ban %s %s'%(choice[0], choice[1]))
	playerlib.getPlayer(choice[0]).banId(choice[1], 1, 'You have been banned for teamflashing: %s min'%choice[1])
	es.tell(userid, '#green', 'banned')

def punish2():
	if is_authed(es.getcmduserid()):
		popuplib.send('Team Flasher', es.getcmduserid())
	else:
		es.tell(es.getcmduserid(), '#green', 'You are not authorized to run this command')

def tell(u):
	es.tell(u, '#green', 'Do Not Flash Teamates!')
	es.centertell(u, 'Do Not Flash Teammates!')
	usermsg.hudhint(u, 'Do Not Flash Teammates!')
	es.menu(10, u, 'Do Not Flash Teammates')

def rflash2(userid, choice, popupid):
	global restricted
	if es.getplayersteamid(choice[0]) in restricted:
		gamethread.cancelDelayed('restrict_%s'%es.getplayersteamid(choice[0]))
		restricted.remove(es.getplayersteamid(choice[0]))
	restricted.append(es.getplayersteamid(choice[0]))
	gamethread.delayedname(choice[1] * 60, 'restrict_%s'%es.getplayersteamid(choice[0]), unban_flash, es.getplayersteamid(choice[0]))
	tell(choice[0])
	es.tell(userid, '#multi', '#greenYou have executed #lightgreen%s#green on #lightgreen%s'%(c, playerlib.getPlayer(u).get('name')))
	remove_flash(choice[0])

def remove_flash(userid):
	for index in es.createentitylist('weapon_flashbang'):
		if int(es.getplayerhandle(userid)) == int(es.getindexprop(index, "CBaseEntity.m_hOwnerEntity")):
			es.server.queuecmd('es_xremove %s'%index)
			es.sexec(userid, 'lastinv')
			es.tell(userid, '#green', 'Because of previous team flashing, the flashbang is restricted for you')

def unban_flash(steamid):
	global restricted
	restricted.remove(steamid)

def item_pickup(ev):
	if es.getplayersteamid(ev['userid']) in restricted and ev['item'] == 'flashbang':
		remove_flash(ev['userid'])

def restrict_flash_filter(userid, args):
	if args[0].lower() == 'buy':
		if args[1].lower() == 'flashbang':
			if es.getplayersteamid(userid) in restricted:
				es.tell(userid, '#green', 'Because of previous team flashing, the flashbang is restricted for you')
				return False
	return True

def setup_auth(): # Thanks, SD
	global isAuthed
	if services.isRegistered('auth'):
		auth_service = services.use('auth')
		auth_service.registerCapability('flash_admin', auth_service.ADMIN)
		isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'flash_admin')
	else:
		isAuthed = lambda x: False

def return_admins():
	if os.path.isfile(es.getAddonPath('flash').replace('addons/eventscripts/flash', 'cfg/mani_admin_plugin/clients.txt')):
		admins = []
		a = open(es.getAddonPath('flash').replace('addons/eventscripts/flash', 'cfg/mani_admin_plugin/clients.txt'), 'r')
		b = a.readlines()
		a.close()
		c = []
		for a in b:
			a = a.replace('\t', '').replace(' ', '')
			if not a.startswith('//'):
				c.append(a)
		for a in c:
			if a.lower().startswith('"steam""steam_0:'):
				admins.append(a.lower().replace('"steam""', '').replace('"', '').replace('\n', '').upper())
		return admins

setup_auth()
es.addons.registerClientCommandFilter(restrict_flash_filter) 

